﻿
namespace ExtensibleObjectProperties
{
	public class xObject
	{
		protected bool		m_bool_property			= false;
		protected string	m_string_property		= "Hi, I am string property";
		protected int		m_int_property			= 0;
		protected string	m_not_shown_property	= "Hi, I am not available!";

		protected xPropertyList		m_properties;

		public xObject()
		{
			m_properties	= new xPropertyList( this);

			m_properties.SetBuiltinPropertyValue( "StringProperty",		StringProperty);
			m_properties.SetBuiltinPropertyValue( "IntProperty",		IntProperty);
			m_properties.SetBuiltinPropertyValue( "BoolProperty",		BoolProperty);

			// this call will fail because the property doesn't define the required Sys.Attribute
			m_properties.SetBuiltinPropertyValue( "NotShownStringProperty",	NotShownStringProperty);
		}


		public xPropertyList xProperties
		{
			get { return m_properties; }
		}

		[xSysProperty]
		public bool BoolProperty
		{
			get { return m_bool_property; }
			set { m_bool_property = value; }
		}

		[xSysProperty]
		public string StringProperty
		{
			get { return m_string_property; }
			set { m_string_property = value; }
		}

		[xSysProperty]
		public int IntProperty
		{
			get { return m_int_property; }
			set { m_int_property = value; }
		}

		public string NotShownStringProperty
		{
			get { return m_not_shown_property; }
			set { m_not_shown_property = value; }
		}

	
	}
}
